unit BIOS_CRT; interface
  type shortcard = byte;

  var screen_page: byte;                          {     }
      screen_attr: byte;                 {      }
      screen_mode: byte;                                         {  }
      screen_cols: byte;                              {     }
      screen_rows: byte;                              {     }

      message: text;

  procedure gotoxy(x, y: shortcard);
    {-  }

  procedure clreol;
    {-     }

  function readkeyword: word;
    {-        scan code }

  function keypressed: boolean;
    {-  }

implementation
  uses DOS;

  function keypressed: boolean; {$L keypressed.obj} external;
    {-  }

  function readkeyword: word; {$L readkeyword.obj} external;

  procedure clreol;
    var x1, y1: byte; r: registers;
  begin
    r.AH:= 3; r.BH:= screen_page; intr($10, r);
    r.BH:= screen_attr; r.Ax:= $0600;
    r.Cx:= r.Dx; r.DL:= screen_cols -1;
    intr($10, r);
  end { clreol };

  procedure gotoxy(x, y: shortcard);
    var r: registers;
  begin
    r.AH:= 2; r.BH:= screen_page;
    r.DL:= x-1; r.DH:= y-1; intr($10, r);
  end { gotoxy };

  procedure init;
    var r: registers;
  begin
    r.AH:= 15; intr($10, r);
    screen_page:= r.BH;
    screen_cols:= r.AH;
    screen_mode:= r.AL;
    r.AH:= 8; intr($10, r);
    screen_attr:= r.AH;
    r.Ax:= $1a00; intr($10, r);
    if r.Al = $1a then begin                               { test for EGA/VGA }
      screen_rows:= mem[$0000:$0484] +1;
    end { if };
  end { init };

  type FIB = record               { structure of a Turbo File Interface Block }
         Handle:    Word;             {      HANDLE }
         Mode:      Word;
         BufSize:   Word;
         Private:   Word;
         BufPos:    Word;
         BufEnd:    Word;
         BufPtr:    pointer {^TextBuffer};
         OpenProc:  Pointer;
         InOutProc: Pointer;
         FlushProc: Pointer;
         CloseProc: Pointer;
         UserData:  array[1..16] of Byte;
         Name:      array[0..79] of Char;
         Buffer:    array[0..127] of Char;
       end { FIB };
begin
  { Open message as stnadard error file }
  Assign(message, ''); Rewrite(message);
  with FIB(message) do begin
    handle:= 2; BufSize:= 1;
  end { with };
  screen_rows:= 25;
  init;
end { BIOS_CRT }.